diff --git a/default-configs/targets/aarch64-softmmu.mak b/default-configs/targets/aarch64-softmmu.mak
index 53f83ea81f..4eff428074 100644
--- a/default-configs/targets/aarch64-softmmu.mak
+++ b/default-configs/targets/aarch64-softmmu.mak
@@ -1,5 +1,4 @@
 TARGET_AARCH64=y
 TARGET_BASE_ARCH=arm
-TARGET_ABI_DIR=aarch64
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/aarch64-core.xml gdb-xml/aarch64-fpu.xml gdb-xml/arm-core.xml gdb-xml/arm-vfp.xml gdb-xml/arm-vfp3.xml gdb-xml/arm-neon.xml gdb-xml/arm-m-profile.xml
diff --git a/default-configs/targets/alpha-softmmu.mak b/default-configs/targets/alpha-softmmu.mak
index b78114b028..8a484c9775 100644
--- a/default-configs/targets/alpha-softmmu.mak
+++ b/default-configs/targets/alpha-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_ALPHA=y
 TARGET_BASE_ARCH=alpha
-TARGET_ABI_DIR=alpha
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/arm-softmmu.mak b/default-configs/targets/arm-softmmu.mak
index d40b995f25..5923f9b203 100644
--- a/default-configs/targets/arm-softmmu.mak
+++ b/default-configs/targets/arm-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_ARM=y
 TARGET_BASE_ARCH=arm
-TARGET_ABI_DIR=arm
-TARGET_SYSTBL_ABI=common,oabi
-TARGET_SYSTBL=syscall.tbl
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/arm-core.xml gdb-xml/arm-vfp.xml gdb-xml/arm-vfp3.xml gdb-xml/arm-neon.xml gdb-xml/arm-m-profile.xml
diff --git a/default-configs/targets/avr-softmmu.mak b/default-configs/targets/avr-softmmu.mak
index ecd292b2f7..46b6da717c 100644
--- a/default-configs/targets/avr-softmmu.mak
+++ b/default-configs/targets/avr-softmmu.mak
@@ -1,4 +1,3 @@
 TARGET_AVR=y
 TARGET_BASE_ARCH=avr
-TARGET_ABI_DIR=avr
 TARGET_XML_FILES= gdb-xml/avr-cpu.xml
diff --git a/default-configs/targets/cris-softmmu.mak b/default-configs/targets/cris-softmmu.mak
index ba61135172..1f7b44114b 100644
--- a/default-configs/targets/cris-softmmu.mak
+++ b/default-configs/targets/cris-softmmu.mak
@@ -1,3 +1,2 @@
 TARGET_CRIS=y
 TARGET_BASE_ARCH=cris
-TARGET_ABI_DIR=cris
diff --git a/default-configs/targets/hppa-softmmu.mak b/default-configs/targets/hppa-softmmu.mak
index 617c6483c0..c4ee4e6c51 100644
--- a/default-configs/targets/hppa-softmmu.mak
+++ b/default-configs/targets/hppa-softmmu.mak
@@ -1,8 +1,5 @@
 TARGET_HPPA=y
 TARGET_BASE_ARCH=hppa
-TARGET_ABI_DIR=hppa
-TARGET_SYSTBL_ABI=common,32
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/i386-bsd-user.mak b/default-configs/targets/i386-bsd-user.mak
index 34b52e9ee2..c58db819ae 100644
--- a/default-configs/targets/i386-bsd-user.mak
+++ b/default-configs/targets/i386-bsd-user.mak
@@ -1,6 +1,4 @@
 TARGET_I386=y
 TARGET_BASE_ARCH=i386
 TARGET_ABI_DIR=i386
-TARGET_SYSTBL_ABI=i386
-TARGET_SYSTBL=syscall_32.tbl
 TARGET_XML_FILES= gdb-xml/i386-32bit.xml
diff --git a/default-configs/targets/i386-softmmu.mak b/default-configs/targets/i386-softmmu.mak
index be9198bb84..4e2eb9f369 100644
--- a/default-configs/targets/i386-softmmu.mak
+++ b/default-configs/targets/i386-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_I386=y
 TARGET_BASE_ARCH=i386
-TARGET_ABI_DIR=i386
-TARGET_SYSTBL_ABI=i386
-TARGET_SYSTBL=syscall_32.tbl
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/i386-32bit.xml
diff --git a/default-configs/targets/lm32-softmmu.mak b/default-configs/targets/lm32-softmmu.mak
index c327d27d5f..2c4b8eab79 100644
--- a/default-configs/targets/lm32-softmmu.mak
+++ b/default-configs/targets/lm32-softmmu.mak
@@ -1,4 +1,3 @@
 TARGET_LM32=y
 TARGET_BASE_ARCH=lm32
-TARGET_ABI_DIR=lm32
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/m68k-softmmu.mak b/default-configs/targets/m68k-softmmu.mak
index f8bf4fc5ac..991e626677 100644
--- a/default-configs/targets/m68k-softmmu.mak
+++ b/default-configs/targets/m68k-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_M68K=y
 TARGET_BASE_ARCH=m68k
-TARGET_ABI_DIR=m68k
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_WORDS_BIGENDIAN=y
 TARGET_XML_FILES= gdb-xml/cf-core.xml gdb-xml/cf-fp.xml gdb-xml/m68k-core.xml gdb-xml/m68k-fp.xml
diff --git a/default-configs/targets/microblaze-softmmu.mak b/default-configs/targets/microblaze-softmmu.mak
index 1b0a76a61f..24594862bf 100644
--- a/default-configs/targets/microblaze-softmmu.mak
+++ b/default-configs/targets/microblaze-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_MICROBLAZE=y
 TARGET_BASE_ARCH=microblaze
-TARGET_ABI_DIR=microblaze
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_WORDS_BIGENDIAN=y
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/microblazeel-softmmu.mak b/default-configs/targets/microblazeel-softmmu.mak
index 3a2cf8be0f..5817a63755 100644
--- a/default-configs/targets/microblazeel-softmmu.mak
+++ b/default-configs/targets/microblazeel-softmmu.mak
@@ -1,6 +1,3 @@
 TARGET_MICROBLAZE=y
 TARGET_BASE_ARCH=microblaze
-TARGET_ABI_DIR=microblaze
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/mips-softmmu.mak b/default-configs/targets/mips-softmmu.mak
index 8ab9ff2ac9..ba58d6827e 100644
--- a/default-configs/targets/mips-softmmu.mak
+++ b/default-configs/targets/mips-softmmu.mak
@@ -1,9 +1,6 @@
 TARGET_ABI_MIPSO32=y
 TARGET_MIPS=y
 TARGET_BASE_ARCH=mips
-TARGET_ABI_DIR=mips
-TARGET_SYSTBL_ABI=o32
-TARGET_SYSTBL=syscall_o32.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/mips64-softmmu.mak b/default-configs/targets/mips64-softmmu.mak
index c02c5460a7..4837a12cac 100644
--- a/default-configs/targets/mips64-softmmu.mak
+++ b/default-configs/targets/mips64-softmmu.mak
@@ -1,8 +1,5 @@
 TARGET_ABI_MIPSN64=y
 TARGET_MIPS64=y
 TARGET_BASE_ARCH=mips
-TARGET_ABI_DIR=mips64
-TARGET_SYSTBL_ABI=n64
-TARGET_SYSTBL=syscall_n64.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/mips64el-softmmu.mak b/default-configs/targets/mips64el-softmmu.mak
index 8cbbc38e78..93e3f25903 100644
--- a/default-configs/targets/mips64el-softmmu.mak
+++ b/default-configs/targets/mips64el-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_ABI_MIPSN64=y
 TARGET_MIPS64=y
 TARGET_BASE_ARCH=mips
-TARGET_ABI_DIR=mips64
-TARGET_SYSTBL_ABI=n64
-TARGET_SYSTBL=syscall_n64.tbl
 TARGET_ALIGNED_ONLY=y
diff --git a/default-configs/targets/mipsel-softmmu.mak b/default-configs/targets/mipsel-softmmu.mak
index afa0851887..1528516b5d 100644
--- a/default-configs/targets/mipsel-softmmu.mak
+++ b/default-configs/targets/mipsel-softmmu.mak
@@ -1,8 +1,5 @@
 TARGET_ABI_MIPSO32=y
 TARGET_MIPS=y
 TARGET_BASE_ARCH=mips
-TARGET_ABI_DIR=mips
-TARGET_SYSTBL_ABI=o32
-TARGET_SYSTBL=syscall_o32.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/moxie-softmmu.mak b/default-configs/targets/moxie-softmmu.mak
index da093f5b36..ada92a6b5b 100644
--- a/default-configs/targets/moxie-softmmu.mak
+++ b/default-configs/targets/moxie-softmmu.mak
@@ -1,4 +1,3 @@
 TARGET_MOXIE=y
 TARGET_BASE_ARCH=moxie
-TARGET_ABI_DIR=moxie
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/nios2-softmmu.mak b/default-configs/targets/nios2-softmmu.mak
index a2308a16aa..f10f08d0ca 100644
--- a/default-configs/targets/nios2-softmmu.mak
+++ b/default-configs/targets/nios2-softmmu.mak
@@ -1,3 +1,2 @@
 TARGET_NIOS2=y
 TARGET_BASE_ARCH=nios2
-TARGET_ABI_DIR=nios2
diff --git a/default-configs/targets/or1k-softmmu.mak b/default-configs/targets/or1k-softmmu.mak
index 2f5ff844df..a922266a98 100644
--- a/default-configs/targets/or1k-softmmu.mak
+++ b/default-configs/targets/or1k-softmmu.mak
@@ -1,4 +1,3 @@
 TARGET_OPENRISC=y
 TARGET_BASE_ARCH=openrisc
-TARGET_ABI_DIR=openrisc
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/ppc-softmmu.mak b/default-configs/targets/ppc-softmmu.mak
index c4d912bfb1..1b6d091cfb 100644
--- a/default-configs/targets/ppc-softmmu.mak
+++ b/default-configs/targets/ppc-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_PPC=y
 TARGET_BASE_ARCH=ppc
-TARGET_ABI_DIR=ppc
-TARGET_SYSTBL_ABI=common,nospu,32
-TARGET_SYSTBL=syscall.tbl
 TARGET_WORDS_BIGENDIAN=y
 TARGET_XML_FILES= gdb-xml/power-core.xml gdb-xml/power-fpu.xml gdb-xml/power-altivec.xml gdb-xml/power-spe.xml
diff --git a/default-configs/targets/ppc64-softmmu.mak b/default-configs/targets/ppc64-softmmu.mak
index a73211918a..e431feffeb 100644
--- a/default-configs/targets/ppc64-softmmu.mak
+++ b/default-configs/targets/ppc64-softmmu.mak
@@ -1,8 +1,5 @@
 TARGET_PPC64=y
 TARGET_BASE_ARCH=ppc
-TARGET_ABI_DIR=ppc
-TARGET_SYSTBL_ABI=common,nospu,64
-TARGET_SYSTBL=syscall.tbl
 TARGET_WORDS_BIGENDIAN=y
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/power64-core.xml gdb-xml/power-fpu.xml gdb-xml/power-altivec.xml gdb-xml/power-spe.xml gdb-xml/power-vsx.xml
diff --git a/default-configs/targets/riscv32-softmmu.mak b/default-configs/targets/riscv32-softmmu.mak
index 35e5b2fb85..caa5829af8 100644
--- a/default-configs/targets/riscv32-softmmu.mak
+++ b/default-configs/targets/riscv32-softmmu.mak
@@ -1,5 +1,4 @@
 TARGET_RISCV32=y
 TARGET_BASE_ARCH=riscv
-TARGET_ABI_DIR=riscv
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/riscv-32bit-cpu.xml gdb-xml/riscv-32bit-fpu.xml gdb-xml/riscv-64bit-fpu.xml gdb-xml/riscv-32bit-csr.xml gdb-xml/riscv-32bit-virtual.xml
diff --git a/default-configs/targets/riscv64-softmmu.mak b/default-configs/targets/riscv64-softmmu.mak
index 4b9a61cd8f..e190c0363b 100644
--- a/default-configs/targets/riscv64-softmmu.mak
+++ b/default-configs/targets/riscv64-softmmu.mak
@@ -1,5 +1,4 @@
 TARGET_RISCV64=y
 TARGET_BASE_ARCH=riscv
-TARGET_ABI_DIR=riscv
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/riscv-64bit-cpu.xml gdb-xml/riscv-32bit-fpu.xml gdb-xml/riscv-64bit-fpu.xml gdb-xml/riscv-64bit-csr.xml gdb-xml/riscv-64bit-virtual.xml
diff --git a/default-configs/targets/rx-softmmu.mak b/default-configs/targets/rx-softmmu.mak
index 52a8c0df10..37b365475f 100644
--- a/default-configs/targets/rx-softmmu.mak
+++ b/default-configs/targets/rx-softmmu.mak
@@ -1,4 +1,3 @@
 TARGET_RX=y
 TARGET_BASE_ARCH=rx
-TARGET_ABI_DIR=rx
 TARGET_XML_FILES= gdb-xml/rx-core.xml
diff --git a/default-configs/targets/s390x-softmmu.mak b/default-configs/targets/s390x-softmmu.mak
index f2a80d3208..f08d25d3c3 100644
--- a/default-configs/targets/s390x-softmmu.mak
+++ b/default-configs/targets/s390x-softmmu.mak
@@ -1,8 +1,5 @@
 TARGET_S390X=y
 TARGET_BASE_ARCH=s390x
-TARGET_ABI_DIR=s390x
-TARGET_SYSTBL_ABI=common,64
-TARGET_SYSTBL=syscall.tbl
 TARGET_WORDS_BIGENDIAN=y
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/s390x-core64.xml gdb-xml/s390-acr.xml gdb-xml/s390-fpr.xml gdb-xml/s390-vx.xml gdb-xml/s390-cr.xml gdb-xml/s390-virt.xml gdb-xml/s390-gs.xml
diff --git a/default-configs/targets/sh4-softmmu.mak b/default-configs/targets/sh4-softmmu.mak
index e46bf0e278..8c7e9eaa7b 100644
--- a/default-configs/targets/sh4-softmmu.mak
+++ b/default-configs/targets/sh4-softmmu.mak
@@ -1,6 +1,3 @@
 TARGET_SH4=y
 TARGET_BASE_ARCH=sh4
-TARGET_ABI_DIR=sh4
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
diff --git a/default-configs/targets/sh4eb-softmmu.mak b/default-configs/targets/sh4eb-softmmu.mak
index db4140ec32..f1848b89b6 100644
--- a/default-configs/targets/sh4eb-softmmu.mak
+++ b/default-configs/targets/sh4eb-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_SH4=y
 TARGET_BASE_ARCH=sh4
-TARGET_ABI_DIR=sh4
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/sparc-bsd-user.mak b/default-configs/targets/sparc-bsd-user.mak
index 7f2fcba978..f478255591 100644
--- a/default-configs/targets/sparc-bsd-user.mak
+++ b/default-configs/targets/sparc-bsd-user.mak
@@ -1,7 +1,5 @@
 TARGET_SPARC=y
 TARGET_BASE_ARCH=sparc
 TARGET_ABI_DIR=sparc
-TARGET_SYSTBL_ABI=common,32
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/sparc-softmmu.mak b/default-configs/targets/sparc-softmmu.mak
index 7f2fcba978..fb3dbb0d61 100644
--- a/default-configs/targets/sparc-softmmu.mak
+++ b/default-configs/targets/sparc-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_SPARC=y
 TARGET_BASE_ARCH=sparc
-TARGET_ABI_DIR=sparc
-TARGET_SYSTBL_ABI=common,32
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/sparc64-bsd-user.mak b/default-configs/targets/sparc64-bsd-user.mak
index 817529e587..0ae8ea5420 100644
--- a/default-configs/targets/sparc64-bsd-user.mak
+++ b/default-configs/targets/sparc64-bsd-user.mak
@@ -1,7 +1,5 @@
 TARGET_SPARC64=y
 TARGET_BASE_ARCH=sparc
 TARGET_ABI_DIR=sparc64
-TARGET_SYSTBL_ABI=common,64
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/sparc64-softmmu.mak b/default-configs/targets/sparc64-softmmu.mak
index 817529e587..bc07bfdb0a 100644
--- a/default-configs/targets/sparc64-softmmu.mak
+++ b/default-configs/targets/sparc64-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_SPARC64=y
 TARGET_BASE_ARCH=sparc
-TARGET_ABI_DIR=sparc64
-TARGET_SYSTBL_ABI=common,64
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
diff --git a/default-configs/targets/tricore-softmmu.mak b/default-configs/targets/tricore-softmmu.mak
index 356e5d8669..a29aa2d6dd 100644
--- a/default-configs/targets/tricore-softmmu.mak
+++ b/default-configs/targets/tricore-softmmu.mak
@@ -1,3 +1,2 @@
 TARGET_TRICORE=y
 TARGET_BASE_ARCH=tricore
-TARGET_ABI_DIR=tricore
diff --git a/default-configs/targets/unicore32-softmmu.mak b/default-configs/targets/unicore32-softmmu.mak
index d8c7860ac1..85f37dc88f 100644
--- a/default-configs/targets/unicore32-softmmu.mak
+++ b/default-configs/targets/unicore32-softmmu.mak
@@ -1,3 +1,2 @@
 TARGET_UNICORE32=y
 TARGET_BASE_ARCH=unicore32
-TARGET_ABI_DIR=unicore32
diff --git a/default-configs/targets/x86_64-bsd-user.mak b/default-configs/targets/x86_64-bsd-user.mak
index 6a9418f9ff..935b10e22c 100644
--- a/default-configs/targets/x86_64-bsd-user.mak
+++ b/default-configs/targets/x86_64-bsd-user.mak
@@ -1,6 +1,4 @@
 TARGET_X86_64=y
 TARGET_BASE_ARCH=i386
 TARGET_ABI_DIR=x86_64
-TARGET_SYSTBL_ABI=common,64
-TARGET_SYSTBL=syscall_64.tbl
 TARGET_XML_FILES= gdb-xml/i386-64bit.xml
diff --git a/default-configs/targets/x86_64-softmmu.mak b/default-configs/targets/x86_64-softmmu.mak
index 8b56e6e6da..377c63e823 100644
--- a/default-configs/targets/x86_64-softmmu.mak
+++ b/default-configs/targets/x86_64-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_X86_64=y
 TARGET_BASE_ARCH=i386
-TARGET_ABI_DIR=x86_64
-TARGET_SYSTBL_ABI=common,64
-TARGET_SYSTBL=syscall_64.tbl
 TARGET_SUPPORTS_MTTCG=y
 TARGET_XML_FILES= gdb-xml/i386-64bit.xml
diff --git a/default-configs/targets/xtensa-softmmu.mak b/default-configs/targets/xtensa-softmmu.mak
index 2166f97738..96f892c4a8 100644
--- a/default-configs/targets/xtensa-softmmu.mak
+++ b/default-configs/targets/xtensa-softmmu.mak
@@ -1,7 +1,4 @@
 TARGET_XTENSA=y
 TARGET_BASE_ARCH=xtensa
-TARGET_ABI_DIR=xtensa
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_SUPPORTS_MTTCG=y
diff --git a/default-configs/targets/xtensaeb-softmmu.mak b/default-configs/targets/xtensaeb-softmmu.mak
index 2372d22492..e6f53a1272 100644
--- a/default-configs/targets/xtensaeb-softmmu.mak
+++ b/default-configs/targets/xtensaeb-softmmu.mak
@@ -1,8 +1,5 @@
 TARGET_XTENSA=y
 TARGET_BASE_ARCH=xtensa
-TARGET_ABI_DIR=xtensa
-TARGET_SYSTBL_ABI=common
-TARGET_SYSTBL=syscall.tbl
 TARGET_ALIGNED_ONLY=y
 TARGET_WORDS_BIGENDIAN=y
 TARGET_SUPPORTS_MTTCG=y